#include "descriptor/descriptor.h"

int main(void) {
	
  ITEM concorde_obj, finestrini_obj, engine_turbine_obj, timone_obj, alasx_obj, aladx_obj;  
  ITEM concorde_attribute, engine_turbine_attribute, glass_attribute;  
  ITEM scene, concorde_all;
  
  set_background(0.37, 0.61, 0.85, FALSE);
  set_ambient_light(1,1,1,0.8);

	create_point_light(230.267, 266.929, -96.605, 1.0, 1.0, 1.0, 1, 450, "lightSun1");	
	create_point_light(3.272, -398.066, 34.749, 1, 1, 1, 1.0, 800, "lightSun2");
	create_point_light(69.541, 113.108, -23.985, 1, 1, 1, 1.0, 400, "lightSun3");  
  	create_point_light(-93.741, 233.836, -19.143, 1, 1, 1, 1, 390, "lightSun4");
 
  /*** ATTRIBUTE glass ***/
  glass_attribute = create_attribute("glass_attribute");
  set_color(glass_attribute, 0.2, 0.36, 0.45, 0.5, 0.6);
  set_reflectivity(glass_attribute,1.0,2);
  set_transparency(glass_attribute,0.9,0.6,1,1.9);
   
   /*** ATTRIBUTE turbine_attribute ***/
  engine_turbine_attribute = create_attribute("engine_turbine_attribute");
  set_color(engine_turbine_attribute, 0.19, 0.18, 0.16, 0.2, 0.4);
  set_reflectivity(engine_turbine_attribute,0.02,10); 
  
	 /*** ATTRIBUTE concorde_attribute ***/
  concorde_attribute = create_attribute("concorde_attribute");
  set_color(concorde_attribute, 1.0, 0.98, 0.98 ,0.2,0.6);
  set_reflectivity(concorde_attribute,0.05, 1);
  
 
  /*** READ dei file obj ***/ 
  concorde_obj = read_obj("concordefinale.obj", "concorde");
  engine_turbine_obj = read_obj("engine_turbine.obj", "eng_turb");  
  finestrini_obj = read_obj("finestrini_obj.obj", "finestrini");
  timone_obj = read_obj("timonefine.obj", "timone");
  alasx_obj = read_obj("alasxintera.obj", "alasx");
  aladx_obj = read_obj("aladxintera.obj", "aladx");  
  
  /* setta gli attributi definiti */
  set_attribute(timone_obj,  concorde_attribute);  
  set_attribute(aladx_obj,  concorde_attribute);
  set_attribute(alasx_obj,  concorde_attribute);
  set_attribute(concorde_obj, concorde_attribute);  
  set_attribute(engine_turbine_obj, engine_turbine_attribute);
  set_attribute(finestrini_obj, glass_attribute); 
 
  
  /* TEXTURE ESTERNO CORPO */ 
  set_translate(concorde_obj, -0.1, -30.614,-23.599);
  set_scale(concorde_obj, 0.022, 0.18, 0.019);    
  set_translate(concorde_obj, -1.0, 0.57, 0.12);
  set_projection_texture(concorde_obj, concorde_attribute, "textures/concorde_corpo1.hr", 0, FALSE, 0.3, 0.6);
  set_translate(concorde_obj, 1.0, -0.57, -0.12);
  set_scale(concorde_obj, 1/0.022, 1/0.18, 1/0.019); 
  set_translate(concorde_obj,  0.1, 30.614, 23.599);  
 
  /* TEXTURE ESTERNO ALI */  
  set_translate(alasx_obj, -13.327, -27.105,-31.143);
  set_scale(alasx_obj, 0.05, 0.05, 0.05);    
  set_z_rotate(alasx_obj, 90,1);  
  set_y_rotate(alasx_obj, 90,1);
  set_translate(alasx_obj, 0.0, 0.4, 0.65);  
  set_projection_texture(alasx_obj, concorde_attribute, "textures/ali.hr", 0, FALSE, 0.3, 0.6);	
  set_translate(alasx_obj, 0.0, -0.4, -0.65);	
  set_y_rotate(alasx_obj, -90,1); 	
  set_z_rotate(alasx_obj, -90,1);  
  set_scale(alasx_obj, 1/0.05, 1/0.05, 1/0.05); 
  set_translate(alasx_obj, 13.327, 27.105,31.143);
  
  set_translate(alasx_obj, 0.0, -0.15, 0.0);
  
  set_translate(aladx_obj, 13.046, -24.955,-31.143);
  set_scale(aladx_obj, 0.05, 0.05, 0.05);    
  set_z_rotate(aladx_obj, 90,1);  
  set_y_rotate(aladx_obj, 90,1);
 
  set_translate(aladx_obj, 0.0, -0.1, 0.8);    
  set_projection_texture(aladx_obj, concorde_attribute, "textures/ali.hr", 0, FALSE, 0.3, 0.6);	
  set_translate(aladx_obj, 0.0, 0.1, -0.8);	
  set_y_rotate(aladx_obj, -90,1); 	
  set_z_rotate(aladx_obj, -90,1);  
  set_scale(aladx_obj, 1/0.05, 1/0.05, 1/0.05); 
  set_translate(aladx_obj, -13.046, 24.955, 31.143);
    
  set_translate(aladx_obj, 0.0, -0.15, 0.0);  

    
  /* TEXTURE TIMONE*/
  set_translate(timone_obj, -0.0, -33.415, -53.098);
  set_scale(timone_obj, 0.075, 0.075, 0.075);    
  set_projection_texture(timone_obj, concorde_attribute, "textures/texcoda.hr", 0, FALSE, 0.3, 0.6);
  set_scale(timone_obj, 1/0.075, 1/0.075, 1/0.075); 
  set_translate(timone_obj, 0.0, 33.415, 53.098);
  
  set_translate(timone_obj, 0.0, -0.2, 0.0);
  
  concorde_all = create_list(concorde_obj, "concorde_all");  
  concorde_all = insert_in_list(concorde_all,  engine_turbine_obj);
  concorde_all = insert_in_list(concorde_all, timone_obj);
  concorde_all = insert_in_list(concorde_all, finestrini_obj);
  concorde_all = insert_in_list(concorde_all, alasx_obj);
  concorde_all = insert_in_list(concorde_all, aladx_obj);
  
	  
 int i;
 double angleConcorde;
 double dz, dx, dy;
 
 angleConcorde = dx = dy = dz = 0;
   
  for(i=1; i<=96; i++){
	
	
	dz -= 0.02 ;
	  
	 
	 if (i>25){
		
		angleConcorde = 0.021 * (i - 24);	
		dy = 0.02 * (i -24);
		set_translate(concorde_all, -0.1, -74.162, 60.806);	   
	   set_x_rotate(concorde_all, angleConcorde, 1);
	   set_translate(concorde_all, 0.1, 74.162, -60.806);		
			   
	 }
	 
	 set_translate(concorde_all, dx, dy, dz);
	 save_scene_ani(96, "concorde_ani.ani", "concorde", "scene_concorde", concorde_all);
  }
  return(0);
}
